<script>
  import Layout from "../components/Layout.svelte";
  import {
    Table,
    TableBody,
    TableBodyCell,
    TableBodyRow,
    TableHead,
    TableHeadCell,
    Toggle,
    Button,
    Toast,
    Modal,
    Label,
    Input,
    Textarea,
    Checkbox,
  } from "flowbite-svelte";
  import { FireOutline } from "flowbite-svelte-icons";
  import { urlAPI } from "../utils/constants";
  import { onMount } from "svelte";

  let dataUsuarios = [];
  let dataGrupos = [];
  let defaultModal = false;
  let open = false;
  let toastMessageError = "";

  const initialState = {
    name: "",
    description: "",
    active: false,
  };

  let formData = {
    ...initialState,
  };

  let dataSelected = [];

  const getDataUsuarios = async () => {
    try {
      const response = await fetch(urlAPI + "/correos");
      const result = await response.json();
      dataUsuarios = result[0]; // Asigna los datos de la API a la variable data
    } catch (error) {
      console.error("Error al obtener datos de la API:", error.message);
      toastMessageError = error.message;
      open = true;
    }
  };

  const getDataGrupos = async () => {
    try {
      const response = await fetch(urlAPI + "/grupos");
      const result = await response.json();
      console.log(result);
      dataGrupos = result; // Asigna los datos de la API a la variable data
    } catch (error) {
      console.error("Error al obtener datos de la API:", error.message);
      toastMessageError = error.message;
      // open = true;
    }
  };

  const toggleSelection = (id) => {
    if (dataSelected.includes(id)) {
      dataSelected = dataSelected.filter((item) => item !== id);
    } else {
      dataSelected = [...dataSelected, id];
    }
  };

  function isChecked(id) {
    return dataSelected.includes(id);
  }

  const enviarFormulario = async () => {
    console.log(dataSelected);
    try {
      const response = await fetch(urlAPI + "/grupos", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify({ ...formData, users: dataSelected }),
      });

      const data = await response.json();

      if (data.statusCode == 400) {
        toastMessageError = data.message;
        open = true;
        return;
      }

      formData = initialState;
      defaultModal = false;
      dataSelected = []
      getDataGrupos();
    } catch (error) {
      formData = initialState;
      console.error("Error en la solicitud:", error.message);
      toastMessageError = error.message;
      open = true;
    }
  };

  const cambiarEstado = async (id, state) => {
    // console.log(id, state)
    try {
      const response = await fetch(urlAPI + `/grupos/${id}`, {
        method: "PATCH",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify({
          active: !state
        }),
      });

      const data = await response.json()

      if (data.statusCode == 400) {
        toastMessageError = data.message
        open = true
        return
      }


      setTimeout(() => {
        getDataGrupos();
      }, 500)
      getDataUsuarios();
    } catch (error) {
      formData = initialState;
      console.error("Error en la solicitud:", error.message );
      toastMessageError = error.message
      open = true
    }
  }

  onMount(() => {
    getDataUsuarios();
    getDataGrupos();
  });
</script>

<Layout>
  <Toast bind:open position="bottom-right">
    <FireOutline
      slot="icon"
      class="w-5 h-5 text-primary-500 bg-primary-100 dark:bg-primary-800 dark:text-primary-200"
    />
    {toastMessageError}
  </Toast>
  <Modal title="Crear usuario" bind:open={defaultModal} autoclose>
    <form on:submit|preventDefault={enviarFormulario}>
      <div class="mb-6">
        <Label for="name" class="block mb-2">Nombre de grupo</Label>
        <Input
          id="name"
          size="lg"
          placeholder="Nombre..."
          bind:value={formData.name}
        />
      </div>

      <div class="mb-6">
        <Label for="description" class="block mb-2">Descripción de grupo</Label>
        <Textarea
          id="description"
          size="lg"
          placeholder="Descripción..."
          bind:value={formData.description}
        />
      </div>

      <div class="mb-6">
        <Table hoverable={true}>
          <TableHead>
            <TableHeadCell class="!p-4">
              <Checkbox />
            </TableHeadCell>
            <TableHeadCell>ID</TableHeadCell>
            <TableHeadCell>Nombre de usuario</TableHeadCell>
            <TableHeadCell>Email</TableHeadCell>
          </TableHead>
          <TableBody tableBodyClass="divide-y">
            {#each dataUsuarios as item (item.id)}
              <TableBodyRow key={item.id}>
                <Checkbox
                  checked={isChecked(item.id)}
                  on:change={() => toggleSelection(item.id)}
                />
                <TableBodyCell>{item.id}</TableBodyCell>
                <TableBodyCell>{item.name}</TableBodyCell>
                <TableBodyCell>{item.email}</TableBodyCell>
              </TableBodyRow>
            {/each}
          </TableBody>
        </Table>
      </div>

      <div class="mb-6">
        <Label for="active" class="block mb-2">Estado</Label>
        <Toggle id="active" bind:checked={formData.active}>Activado</Toggle>
      </div>
    </form>
    <svelte:fragment slot="footer">
      <Button on:click={() => enviarFormulario()}>Crear</Button>
      <Button color="alternative">Cancelar</Button>
    </svelte:fragment>
  </Modal>
  <div class="flex items-center justify-between mb-4">
    <h1 class="mb-4">Grupos</h1>
    <Button on:click={() => (defaultModal = true)}>Crear grupo</Button>
  </div>
  <Table>
    <TableHead>
      <TableHeadCell>ID</TableHeadCell>
      <TableHeadCell>Nombre Grupo</TableHeadCell>
      <TableHeadCell>Descripción</TableHeadCell>
      <TableHeadCell>Correos</TableHeadCell>
      <TableHeadCell>Acciones</TableHeadCell>
    </TableHead>
    <TableBody tableBodyClass="divide-y">
      {#each dataGrupos as item (item.id)}
        <TableBodyRow key={item.id}>
          <TableBodyCell>{item.id}</TableBodyCell>
          <TableBodyCell>{item.name}</TableBodyCell>
          <TableBodyCell>{item.description}</TableBodyCell>
          <TableBodyCell>
            {#each item.correos as correo (correo.id)}
              <h1>{correo.email}</h1>
            {/each}
          </TableBodyCell>
          <TableBodyCell>
            <Toggle checked={item.active} on:change={(e) => (cambiarEstado(item.id, item.active))} >Activo</Toggle>
          </TableBodyCell>
        </TableBodyRow>
      {/each}
    </TableBody>
  </Table>
</Layout>
